pragma solidity >=0.6.12;

// Author:	Louis Holbrook <dev@holbrook.no> 0826EDA1702D1E87C6E2875121D2E7BB88C2A746
// SPDX-License-Identifier:	AGPL-3.0-or-later
// File-version: 2

interface IMinter {
	// Tokens are successfully minted; by who, to whom and how much
	event Mint(address indexed _minter, address indexed _beneficiary, uint256 value);

	// The given token has been successfully minted; by who, to whom and how much
	event Mint(address indexed _minter, address indexed _beneficiary, address indexed _token, uint256 value);

	// Mint the specified value of tokens to the specified recipient
	function mintTo(address _beneficiary, uint256 value) external returns (bool);

	// Satisfies ERC5679 for ERC20
	function mint(address _beneficiary, uint256 value, bytes calldata _data) external;

	// Satisfies ERC5679 for ERC721
	function safeMint(address _beneficiary, uint256 value, bytes calldata _data) external;
}
