pragma solidity >=0.6.12;

// Author:	Louis Holbrook <dev@holbrook.no> 0826EDA1702D1E87C6E2875121D2E7BB88C2A746
// SPDX-License-Identifier:	AGPL-3.0-or-later
// File-version: 3

interface IRegistryClient {
	// Address added to store with the given key
	event AddressKey(bytes32 indexed _key, address _address);

	// Return the address of the contract identified by the given byte string
	function addressOf(bytes32) external view returns (address);

	// Indexed accessor for the full list of registred identifiers
	function identifier(uint256) external view returns (bytes32);

	// Number of registered interfaces
	function identifierCount() external view returns (uint256);
}
