pragma solidity >=0.6.12;

// Author:	Louis Holbrook <dev@holbrook.no> 0826EDA1702D1E87C6E2875121D2E7BB88C2A746
// SPDX-License-Identifier:	AGPL-3.0-or-later
// File-version: 1

interface ISeal {
	// Seal state has changed.
	event SealStateChange(bool indexed _final, uint256 _sealState);

	// The current seal state.
	function sealState() external view returns(uint256);

	// The numeric seal state in everything sealable has been sealed.
	function maxSealState() external view returns(uint256);
}
