pragma solidity >=0.6.12;

// Author:	Louis Holbrook <dev@holbrook.no> 0826EDA1702D1E87C6E2875121D2E7BB88C2A746
// SPDX-License-Identifier:	AGPL-3.0-or-later
// File-version: 1

interface ITokenLimit {
	// Returns limit of total value a holder will accept of a specific token.
	// The value limit returned is inclusive; A limit of 42 means any operation resulting in a balance OVER 42 should be rejected.
	// A value of 0 means that no value of the token is accepted.
	function limitOf(address _token, address _holder) external view returns(uint256);
}
