pragma solidity >=0.6.12;

// Author:	Louis Holbrook <dev@holbrook.no> 0826EDA1702D1E87C6E2875121D2E7BB88C2A746
// SPDX-License-Identifier:	AGPL-3.0-or-later
// File-version: 1

interface ITokenVend {
	// A new vended token has been created.
	event TokenCreated(uint256 indexed _tokenIdx, uint256 indexed _supply, address _token);

	// Create corresponding vended tokens for the control token balance of the caller.	
	function getFor(address _token) external returns (uint256);

	// Recover control tokens that were used to retrieve the corresponding vended tokens.
	function withdrawFor(address _token) external returns (uint256);
}
