pragma solidity >=0.6.12;

// Author:	Louis Holbrook <dev@holbrook.no> 0826EDA1702D1E87C6E2875121D2E7BB88C2A746
// SPDX-License-Identifier:	AGPL-3.0-or-later
// File-version: 4

interface IWriter {
	// A writer has been added by _executor
	event WriterAdded(address _writer);

	// A writer has been removed by _executor
	event WriterDeleted(address _writer);

	// Add a new writer to the contract.
	function addWriter(address _writer) external returns (bool);

	// Remove existing writer from the contract.
	function deleteWriter(address _writer) external returns (bool);

	// Check whether the given address is a writer.
	function isWriter(address _writer) external view returns (bool);
}
